/// <reference types="node" />
import File = require('vinyl');
import { IAuthOptions } from 'sp-request';
export declare enum CheckinType {
    minor = 0,
    major = 1,
    overwrite = 2,
    nocheckin = 3
}
export interface ICoreOptions {
    siteUrl: string;
    checkin?: boolean;
    checkinType?: CheckinType;
    checkinMessage?: string;
    notification?: boolean;
    filesMetaData?: IFileMetaData[];
}
export interface IFileMetaData {
    fileName: string;
    updated?: boolean;
    metadata: any;
}
export interface IGlobOptions {
    glob: string | string[];
    folder?: string;
    base?: string;
}
export interface IFileContentOptions {
    fileName: string;
    fileContent: string | Buffer;
    folder: string;
}
export interface IVinylOptions {
    file: File;
    folder?: string;
}
export declare type FileOptions = IGlobOptions | IFileContentOptions | IVinylOptions;
export interface ISPSaveOptions {
    creds: IAuthOptions;
    files: IFileContentOptions[];
    core: ICoreOptions;
}
export declare function isGlobOptions(T: FileOptions): T is IGlobOptions;
export declare function isFileContentOptions(T: FileOptions): T is IFileContentOptions;
export declare function isVinylOptions(T: FileOptions): T is IVinylOptions;
